
TYPO3.Fluid - Bug # 35090

Status: Resolved Priority: Should have
Author: Adrian Föder Category:
Created: 2012-03-21 Assigned To: Adrian Föder
Updated: 2013-07-30 Due date:
Has patch: Yes
Affected Flow version: Git master
Subject: base64-encode of URI-transferred serialized objects
Description

At least Fluid-Widgets add a serialized object to links in order to transfer them across requests.
Maybe it's considerable to base64-encode these serialized objects to avoid problems like the
[[FLOW3:Installation_hints#Unexpected-behavior-with-serialized-objects-in-request-arguments|suhosin's null-byte-omission]].

Additional explanation: serialized objects contain NULL bytes if a property of the object is protected.

Associated revisions
Revision f53ee1c6 - 2013-07-15 13:22 - Adrian Föder

[BUGFIX] Base64-encode widget context

In order to avoid various null-byte-issues as they occur
when serializing an object with protected members (see
[1]); for example with Suhosin or some reverse proxy
implementations; the context object is transferred
in a Base64 encoded state now.

As there is no need to urlencode it anymore, this additionally
saves some bytes.

[1] http://php.net/serialize section "Parameters", subsection Note

Fixes: #35090
Releases: master
Change-Id: Idc9d1bbd944324db0f24ff3ac7fed766d2c473b1

History
#1 - 2012-04-17 16:06 - Adrian Föder
- Assigned To set to Bastian Waidelich

#2 - 2012-09-06 09:50 - Bastian Waidelich
- Assigned To deleted (Bastian Waidelich)

Mh, base64 encoding sounds a bit "expensive" to me, but I can't really judge this atm.
I unassign myself for now so someone else can comment on this

#3 - 2013-07-12 16:29 - Adrian Föder
another reason would be that, apparently, the Pound (http://linux.die.net/man/8/pound) does also not support NULL bytes in URIs: 
http://www.apsis.ch/pound/pound_list/archive/2012/2012-07/1341212883000/index_html?fullMode=1#1341341716000

#4 - 2013-07-12 16:42 - Adrian Föder
- Category set to MVC
- Status changed from New to Accepted
- Assigned To set to Adrian Föder

#5 - 2013-07-12 16:48 - Adrian Föder
- Project changed from TYPO3.Flow to TYPO3.Fluid
- Category deleted (MVC)

#6 - 2013-07-12 16:52 - Adrian Föder
- Subject changed from Evaluate base64_encoding of URI-transferred serialized objects to base64-encode of URI-transferred serialized objects

#7 - 2013-07-12 16:56 - Adrian Föder

as a side note, the URI length w/o base64 encoding, resulting in the need to urlencode it, is 546 bytes; where the base64 encoded variant is 516
characters long.

#8 - 2013-07-12 17:12 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/22264

#9 - 2013-07-15 13:21 - Adrian Föder
- Tracker changed from Task to Bug
- Has patch changed from No to Yes
- Affected Flow version set to Git master

changed to Bug because the current behavior will definitely break for the mentioned circumstances (using Suhosin)

#10 - 2013-07-15 13:23 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/22264

#11 - 2013-07-30 15:37 - Adrian Föder
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:f53ee1c679c828874d5ffec565b6eb202ade9040.
